/*++

Copyright (c) 1990-2000 Microsoft Corporation, All Rights Reserved

Module Name:
    pnp.h

Abstract: 

Author:
    Raju Ramanathan        02/22/2000

Enviroment:
    Kernel Mode Only

Revision History:

--*/

#ifndef _PNP_H_
#define _PNP_H_

#include <ntddk.h>

typedef enum  _DEVICE_STATE {
    STOPPED,            // device stopped
    WORKING,            // started and working
    PENDINGSTOP,        // stop pending
    PENDINGREMOVE,      // remove pending
    SURPRISEREMOVED,    // removed by surprise
    REMOVED,            // removed
    MAX_STATE           // Unknown state -Some error
} DEVICE_STATE, *PDEVICE_STATE;

typedef struct _DEVICE_STATE_TABLE {
    DEVICE_STATE    DevState;
    PCSTR           StateName;
    NTSTATUS        NtStatus;
} DEVICE_STATE_TABLE, *PDEVICE_STATE_TABLE;

DEVICE_STATE_TABLE StateTable[] = {
    { STOPPED,         "STOPPED",         STATUS_INVALID_DEVICE_STATE }, 
    { WORKING,         "WORKING",         STATUS_SUCCESS },
    { PENDINGSTOP,     "PENDINGSTOP",     STATUS_DELETE_PENDING },
    { PENDINGREMOVE,   "PENDINGREMOVE",   STATUS_DELETE_PENDING },
    { SURPRISEREMOVED, "SURPRISEREMOVED", STATUS_DEVICE_REMOVED },
    { REMOVED,         "REMOVED",         STATUS_DEVICE_REMOVED },
    { MAX_STATE,       "UNKNOWN",         STATUS_INVALID_DEVICE_STATE }
};

static char* StateName[] = {
    "STOPPED",
    "WORKING",
    "PENDINGSTOP",
    "PENDINGREMOVE",
    "SURPRISEREMOVED",
    "REMOVED",
    "UNKNOWN"
};

static char *PnpIrpName[] = {
    "IRP_MN_START_DEVICE",
    "IRP_MN_QUERY_REMOVE_DEVICE",
    "IRP_MN_REMOVE_DEVICE",
    "IRP_MN_CANCEL_REMOVE_DEVICE",
    "IRP_MN_STOP_DEVICE",
    "IRP_MN_QUERY_STOP_DEVICE",
    "IRP_MN_CANCEL_STOP_DEVICE",
    "IRP_MN_QUERY_DEVICE_RELATIONS",
    "IRP_MN_QUERY_INTERFACE",
    "IRP_MN_QUERY_CAPABILITIES",
    "IRP_MN_QUERY_RESOURCES",
    "IRP_MN_QUERY_RESOURCE_REQUIREMENTS",
    "IRP_MN_QUERY_DEVICE_TEXT",
    "IRP_MN_FILTER_RESOURCE_REQUIREMENTS",
    "IRP_MN_READ_CONFIG",
    "IRP_MN_WRITE_CONFIG",
    "IRP_MN_EJECT",
    "IRP_MN_SET_LOCK",
    "IRP_MN_QUERY_ID",
    "IRP_MN_QUERY_PNP_DEVICE_STATE",
    "IRP_MN_QUERY_BUS_INFORMATION",
    "IRP_MN_DEVICE_USAGE_NOTIFICATION",
    "IRP_MN_SURPRISE_REMOVAL",
    "Unknown IRP"                   // Ignore the unknown Minor PnP IRP (0x18, 0xff)
};


#endif  // _PNP_H_

// EOF



